<?php

$functions = array('search_check' => array('lib' => 'search.inc',
					   'func' => 'ajax_search_check'),
		   'passwd_check' => array('lib' => 'login.inc',
					   'func' => 'ajax_passwd_check'),
		   'nickname_check' => array('lib' => 'login.inc',
					     'func' => 'ajax_nickname_check'),
		   'tag_add' => array('lib' => 'tags.inc',
				      'func' => 'ajax_tag_add'),
		   'tag_del' => array('lib' => 'tags.inc',
				      'func' => 'ajax_tag_del'),
		   'tag_new' => array('lib' => 'tags.inc',
				      'func' => 'ajax_tag_new'),
		   'tag_exists' => array('lib' => 'tags.inc',
					 'func' => 'ajax_tag_exists'),
		   'bookmark_up' => array('lib' => 'bookmarks.inc',
					  'func' => 'ajax_bookmark_up'),
		   'bookmark_down' => array('lib' => 'bookmarks.inc',
					    'func' => 'ajax_bookmark_down'),
		   'bookmark_del' => array('lib' => 'bookmarks.inc',
					   'func' => 'ajax_bookmark_del'),
		   'bookmark_add' => array('lib' => 'bookmarks.inc',
					   'func' => 'ajax_bookmark_add'),
		   'check_url' => array('lib' => 'functions.inc',
					'func' => 'ajax_check_url'),
		   'check_email' => array('lib' => 'misc.inc',
					  'func' => 'ajax_check_email'),
		   );

function dumpinfo()
{
  global $_SERVER;
  global $_POST;
  global $_GET;

  $info = "\$_SERVER = " . var_export($_SERVER, true);
  $info .= "\n\$_POST = " . var_export($_POST, true);
  $info .= "\n\$_GET = " . var_export($_GET, true);

  $f = fopen("/tmp/zlist.dump", "w");
  fwrite($f, $info);
  fclose($f);
}

function ajax_process()
{
  global $functions;
  global $_POST;

  dumpinfo();

  if (strlen($_POST['function']) && array_key_exists($_POST['function'], $functions)) {
      if (array_key_exists('lib', $functions[$_POST['function']]))
	include_once($functions[$_POST['function']]['lib']);
      if (array_key_exists('func', $functions[$_POST['function']])) {
	if (function_exists($functions[$_POST['function']]['func']))
	  return $functions[$_POST['function']]['func']();
	else
	  return false;
      }
  }

  return false;
}

?>